#include<stdio.h>
#include<stack>

struct state_st{
	int status_id;
	int symbol_id;
	int action_id;
	enum {end,shift,reduce}action;
};

#include "1.h"	//   


std::stack<int> sym_stack;		//  
std::stack<int> status_stack;	//  



const char *source[]={"(","(","(","c","c","c","d","c","d",")",")",")","$end",0};
//const char *source[]={"id","*","id","+","id","$end",0};

//  id 
int GetID(const char *name)
{
	int n;
	for(n=0; symbols[n]; n++) if(!strcmp(symbols[n],name)) break;
	return n;
}

//     
const state_st *FindStatus(int status_id,int symbol_id)
{
	for(int n=0; table[n].action!=state_st::end; n++) 
		if(table[n].status_id==status_id && table[n].symbol_id==symbol_id) return &table[n];

	printf("error!\n\a");
	getchar();
	exit(1);
	return 0;
}

//     (  )
int Reduce(int index,int next_sym)
{
	int n,status;
	const int *it=gram[index];
	int sym=*it;
	printf("reduce: %s ->",symbols[sym]);
	for(n=1; it[n]>=0; n++) printf(" %s",symbols[it[n]]); putchar('\n');
	while(n-->1) {
		sym_stack.pop();
		status_stack.pop();
	}
	printf("push: %s [%d]\n",symbols[sym],sym);
	sym_stack.push(sym);
	if(sym_stack.size()==1 && !strcmp(symbols[next_sym],"$end")) return -1;
	status=status_stack.top();
	const state_st *st=FindStatus(status,sym);
	status=st->action_id;
	printf("push: %d\n",status);
	status_stack.push(status);
	return status;
}


void DumpStack()
{
	printf("status[%d]:",status_stack.size());
	while(!status_stack.empty()) printf(" %d",status_stack.top()),status_stack.pop();
	putchar('\n');
	printf("symbol[%d]:",sym_stack.size());
	while(!sym_stack.empty()) printf(" %s[%d]",symbols[sym_stack.top()],sym_stack.top()),sym_stack.pop();
	putchar('\n');
}


void main()
{
	int status=0;
	int sym,redo=-1;
	const char **text=source;
	status_stack.push(status);
	for(;;) {
		if(redo<0) {
			if(!*text) break;
			sym=GetID(*text);
			printf("read: %s [%d]\n",*text,sym);
			text++;
		}else sym=redo,redo=-1;
		const state_st *st=FindStatus(status,sym);
		switch(st->action) {
		case state_st::shift:
			status=st->action_id;
			printf("push: %s [%d]\n",symbols[sym],sym);
			sym_stack.push(sym);
			printf("push: %d\n",status);
			status_stack.push(status);
			break;
		case state_st::reduce:
			status=Reduce(st->action_id,sym);
			redo=sym;
			break;
		}
		if(status<0) break;
	}
	DumpStack();
	printf("done...\n");
	getchar();
}


